################################

#         WhoOnline            

################################


import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

PRODUCT = 'WhoOnline'

# Load fixture
from Testing import ZopeTestCase

# Permissions / security
from AccessControl.Permissions import access_contents_information, view, add_documents_images_and_files, change_images_and_files, view_management_screens
from AccessControl.SecurityManagement import newSecurityManager, noSecurityManager, getSecurityManager
from AccessControl import Unauthorized
from AccessControl.User import UnrestrictedUser

_all_permissions = ZopeTestCase._standard_permissions

# Some fake stacks
_randon_stacks = [
  ['logged_in', 'plone']
, ['favicon.ico', 'plone']
, ['Folder_icon.gif', 'OFSP', 'misc_']
, ['manage_workspace']
, ['manage_main']
, ['zopelogo_jpg', 'p_']
, ['gawel', 'Members', 'plone']
, ['ControlPanel_icon', 'p_']
, ['manage_workspace', 'custom', 'portal_skins', 'plone']
, ['ProductFolder_icon', 'p_']
, ['gawel', 'Members', 'plone']
, ['plone_icon', 'CMFPlone', 'misc_']
, ['tempfolder.gif', 'TemporaryFolder', 'misc_']
, ['Members', 'plone']
, ['gawel', 'Members', 'plone']
, ['manage_workspace', 'portal_skins']
, ['manage_main', 'portal_skins', 'plone']
, ['manage_workspace', 'custom', 'portal_skins']
, ['UserFolder_icon.gif', 'OFSP', 'misc_']
]
    
# Install our product
ZopeTestCase.installProduct(PRODUCT)



#A *fake* SESSION object. we just need a random number to test
class CUSTOM_SESSION:
    
    session = None

    sessions = [
                  '674166563717134136761','125414354324103540540','1654123514254025454252',
                  '631413641364144513411','674166563717134136761','1254143543241035405403',
                  '674166563717134136761','6757132541571235411321','165412351425402sdf425',
                  '687165413757132541571','1254143543241035405403','165412351425402545425',
                  '674166563717134136761','125414354324103540540','1654123514254025454252',
                  '631413641364144513411','674166563717134136761','1254143543241035405403',
                ]

    def getId(self):
        if len(self.sessions)>0:
            self.session = self.sessions.pop(0)
        else:
            self.session =  self.sessions.pop(0)
        return self.session


#A *fake* request object. return randomly auth users and Anonymous and some test stacks
class CUSTOM_REQUEST:

    _user = stack = None

    users = [
                 'jacky','Anonymous','georges','bylly','vince','gawel',
                 'Anonymous','georges','Anonymous','vince','gawel',
                 'jacky','Anonymous','georges','bylly','vince','gawel',
                 'Anonymous','georges','Anonymous','vince','gawel',
                 'jacky','Anonymous','georges','bylly','vince','gawel',
                 'Anonymous','georges','Anonymous','vince','gawel',
              ]

    SESSION = CUSTOM_SESSION()

    def get(self,p1=None,p2=None):
        return self.stack

    def _authUserPW(self):
        self._user = self.users.pop(0)
        if self._user == 'Anonymous':
            return self._user
        else:
            return (self._user,'pass')


class TestWhoOnline(ZopeTestCase.ZopeTestCase,):
    

    def test_00_Create(self,):
        # Now, installs our product's
        
        request = CUSTOM_REQUEST()
        
        #Add our products
        self.folder.manage_addProduct[PRODUCT].manage_addWhoOnline(PRODUCT,PRODUCT,300)
        
        Obj = self.folder.restrictedTraverse(PRODUCT)

        # On second idle is nice
        Obj.idle = 1

        for stack in _randon_stacks:
            request.stack=stack
            # A fake HTTP request
            Obj(None,request,None)
            Obj.getActiveMembers()
            Obj.getActiveVisitors()

        Obj._purge()

        # finally remove our object
        self.folder.manage_delObjects(ids=[PRODUCT])
        
        print "\nPass the first test"

    def test_01_Create(self,):
        # Test Whith ignore ZMI
        
        request = CUSTOM_REQUEST()

        #Add our products
        self.folder.manage_addProduct[PRODUCT].manage_addWhoOnline(PRODUCT,PRODUCT,300)

        Obj = self.folder.restrictedTraverse(PRODUCT)

        # We want ignore the ZMI request
        Obj.ignore_ZMI = 1

        # On second idle is nice
        Obj.idle = 1

        for stack in _randon_stacks:
            request.stack=stack
            # A fake HTTP request
            Obj(None,request,None)
            Obj.getActiveMembers()
            Obj.getActiveVisitors()
            
        Obj._purge()

        # finally remove our object
        self.folder.manage_delObjects(ids=[PRODUCT])
        print "\nPass the second test"
                                                                                                                

if __name__ == '__main__':
    framework(descriptions=1, verbosity=1)
else:
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        suite.addTest(unittest.makeSuite(TestWhoOnline))
        return suite

